import { SelectQueryBuilder } from "typeorm";
import CommonHelper from "../helpers/common";
import { OrmHelper } from "../helpers/orm";
import { CardType } from "entity";

export class CardTypeModel {
    static async list(filterObj = {}, filterAny: string = ""): Promise<SelectQueryBuilder<any>> {
        const repo = OrmHelper.DB.getRepository(CardType);
        let whereAttr = [];
        let whereVal: any = {};
        if (filterObj) {
            const filterResult = CommonHelper.handleQueryFilter(filterObj);
            whereAttr = [...whereAttr, ...filterResult.whereAttr];
            whereVal = { ...whereVal, ...filterResult.whereVal };
        }

        if (filterAny && filterAny !== "" && filterAny !== null && filterAny !== undefined) {
            const filterResult = CommonHelper.handleFilter({
                filter: JSON.stringify({ any: filterAny }),
                col_any_eq: [],
                col_any_like: ["name"],
            });

            if (filterResult.whereAttr && filterResult.whereAttr !== "") {
                whereAttr = [...whereAttr, filterResult.whereAttr];
                whereVal = { ...whereVal, ...filterResult.whereVal };
            }
        }

        var query = repo.createQueryBuilder("card_type");
        if (whereAttr.length != 0) {
            query = query.where(whereAttr.join(" and "), whereVal);
        }

        return query;
    }
}